/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_TimePointTypes;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_TimePointTypes;


/**
 * This class represents TimePointTypes - CID6146
 */
public class TimePointTypes_CID6146 
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * Instantiates a new TimePointTypes_CID6146 Template 
	 */
	public TimePointTypes_CID6146()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumTimePointTypes Object of EnumCM_TimePointTypes represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_TimePointTypes enumTimePointTypes)
	{
		switch(enumTimePointTypes)
		{
		case BASELINE:
			this.strCodeValue = EnumCV_TimePointTypes.BASELINE_C1442488
					.getValue();
			break;
		case PRETREATMENT:
			this.strCodeValue = EnumCV_TimePointTypes.PRETREATMENT_C3539075
					.getValue();
			break;
		case POSTTREATMENT:
			this.strCodeValue = EnumCV_TimePointTypes.POSTTREATMENT_126074
					.getValue();
			break;
		case ELIGIBILITY:
			this.strCodeValue = EnumCV_TimePointTypes.ELIGIBILITY_126075
					.getValue();
			break;
		case UNSCHEDULED:
			this.strCodeValue = EnumCV_TimePointTypes.UNSCHEDULED_C1699701
					.getValue();
			break;
		case NADIR:
			this.strCodeValue = EnumCV_TimePointTypes.NADIR_C1708760.getValue();
			break;
		}
	}

	/**
	 * Sets the value for TimePointTypes
	 * @param enumTimePointTypes Object of EnumCM_TimePointTypes.
	 */
	public void setTimePointTypes(EnumCM_TimePointTypes enumTimePointTypes)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumTimePointTypes.getValue();
		if(strCodeMeaning.equalsIgnoreCase(EnumCM_TimePointTypes.POSTTREATMENT.getValue())||strCodeMeaning.equalsIgnoreCase(EnumCM_TimePointTypes.ELIGIBILITY.getValue()))
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.DCM.getValue();
		else
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.UMLS.getValue();
		/**
		 * set code Value
		 */
		setCodeValue(enumTimePointTypes);
	}
}
